//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <windows.h>
#include <Common.h>
#include "FarPlugin.h"
#include "FarConfiguration.h"
//---------------------------------------------------------------------------
#pragma argsused
//---------------------------------------------------------------------------
#define DLLEXPORT __declspec(dllexport)
//---------------------------------------------------------------------------
TCustomFarPlugin * __fastcall CreateFarPlugin(THandle Handle);
//---------------------------------------------------------------------------
DLLEXPORT int WINAPI GetMinFarVersion(void)
{
  assert(FarPlugin);
  return FarPlugin->GetMinFarVersion();
}
//---------------------------------------------------------------------------
DLLEXPORT void WINAPI SetStartupInfo(const struct PluginStartupInfo * Info)
{
  assert(FarPlugin);
  return FarPlugin->SetStartupInfo(Info);
}
//---------------------------------------------------------------------------
DLLEXPORT void WINAPI ExitFAR()
{
  assert(FarPlugin);
  return FarPlugin->ExitFAR();
}
//---------------------------------------------------------------------------
DLLEXPORT void WINAPI GetPluginInfo(struct PluginInfo * Info)
{
  assert(FarPlugin);
  return FarPlugin->GetPluginInfo(Info);
}
//---------------------------------------------------------------------------
DLLEXPORT int WINAPI Configure(int Item)
{
  assert(FarPlugin);
  return FarPlugin->Configure(Item);
}
//---------------------------------------------------------------------------
DLLEXPORT HANDLE WINAPI OpenPlugin(int OpenFrom, int Item)
{
  assert(FarPlugin);
  return FarPlugin->OpenPlugin(OpenFrom, Item);
}
//---------------------------------------------------------------------------
DLLEXPORT void WINAPI ClosePlugin(HANDLE Plugin)
{
  assert(FarPlugin);
  return FarPlugin->ClosePlugin(Plugin);
}
//---------------------------------------------------------------------------
DLLEXPORT void WINAPI GetOpenPluginInfo(HANDLE Plugin, struct OpenPluginInfo * Info)
{
  assert(FarPlugin);
  return FarPlugin->GetOpenPluginInfo(Plugin, Info);
}
//---------------------------------------------------------------------------
DLLEXPORT int WINAPI GetFindData(HANDLE Plugin,
  struct PluginPanelItem ** PanelItem, int * ItemsNumber, int OpMode)
{
  assert(FarPlugin);
  return FarPlugin->GetFindData(Plugin, PanelItem, ItemsNumber, OpMode);
}
//---------------------------------------------------------------------------
DLLEXPORT void WINAPI FreeFindData(HANDLE Plugin, struct PluginPanelItem * PanelItem,
  int ItemsNumber)
{
  assert(FarPlugin);
  return FarPlugin->FreeFindData(Plugin, PanelItem, ItemsNumber);
}
//---------------------------------------------------------------------------
DLLEXPORT int WINAPI ProcessHostFile(HANDLE Plugin,
  struct PluginPanelItem * PanelItem, int ItemsNumber, int OpMode)
{
  assert(FarPlugin);
  return FarPlugin->ProcessHostFile(Plugin, PanelItem, ItemsNumber, OpMode);
}
//---------------------------------------------------------------------------
DLLEXPORT int WINAPI ProcessKey(HANDLE Plugin, int Key, unsigned int ControlState)
{
  assert(FarPlugin);
  return FarPlugin->ProcessKey(Plugin, Key, ControlState);
}
//---------------------------------------------------------------------------
DLLEXPORT int WINAPI ProcessEvent(HANDLE Plugin, int Event, void * Param)
{
  assert(FarPlugin);
  return FarPlugin->ProcessEvent(Plugin, Event, Param);
}
//---------------------------------------------------------------------------
DLLEXPORT int WINAPI SetDirectory(HANDLE Plugin, const char * Dir,
  int OpMode)
{
  assert(FarPlugin);
  return FarPlugin->SetDirectory(Plugin, Dir, OpMode);
}
//---------------------------------------------------------------------------
DLLEXPORT int WINAPI MakeDirectory(HANDLE Plugin, char * Name, int OpMode)
{
  assert(FarPlugin);
  return FarPlugin->MakeDirectory(Plugin, Name, OpMode);
}
//---------------------------------------------------------------------------
DLLEXPORT int WINAPI DeleteFiles(HANDLE Plugin, struct PluginPanelItem *PanelItem,
  int ItemsNumber, int OpMode)
{
  assert(FarPlugin);
  return FarPlugin->DeleteFiles(Plugin, PanelItem, ItemsNumber, OpMode);
}
//---------------------------------------------------------------------------
DLLEXPORT int WINAPI GetFiles(HANDLE Plugin, struct PluginPanelItem *PanelItem,
  int ItemsNumber, int Move, char * DestPath, int OpMode)
{
  assert(FarPlugin);
  return FarPlugin->GetFiles(Plugin, PanelItem, ItemsNumber,
    Move, DestPath, OpMode);
}
//---------------------------------------------------------------------------
DLLEXPORT int WINAPI PutFiles(HANDLE Plugin, struct PluginPanelItem *PanelItem,
  int ItemsNumber, int Move, int OpMode)
{
  assert(FarPlugin);
  return FarPlugin->PutFiles(Plugin, PanelItem, ItemsNumber,
    Move, OpMode);
}
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE HInst, unsigned long Reason, void * /*Reserved*/)
{
  static int Processes = 0;

  switch (Reason)
  {
    case DLL_PROCESS_ATTACH:
      FarPlugin = CreateFarPlugin((THandle)HInst);

      assert(!Processes);
      Processes++;

      if (ThousandSeparator == '\xA0')
      {
        ThousandSeparator = ' ';
      }
      break;

    case DLL_PROCESS_DETACH:
      assert(Processes);
      Processes--;
      if (!Processes)
      {
        assert(FarPlugin);
        SAFE_DESTROY(FarPlugin);
      }
      break;
  }
  return true;
}
//---------------------------------------------------------------------------

